diff --git a/src/main/java/net/minecraft/client/entity/particle/ParticlePuffRGB.java b/src/main/java/net/minecraft/client/entity/particle/ParticlePuffRGB.java
new file mode 100644
index 000000000..51abc180b
--- /dev/null
+++ b/src/main/java/net/minecraft/client/entity/particle/ParticlePuffRGB.java
@@ -0,0 +1,108 @@
+package net.minecraft.client.entity.particle;
+
+import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.enums.LightLayer;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+
+public class ParticlePuffRGB extends Particle {
+    private final float oSize;
+    private int brightness;
+
+    public ParticlePuffRGB(World world, double x, double y, double z, float red, float green, float blue, int brightness) {
+        this(world, x, y, z, 1.0F, red, green, blue, brightness);
+    }
+
+    public ParticlePuffRGB(World world, double x, double y, double z, float scale, float red, float green, float blue, int brightness) {
+        super(world, x, y, z, 0.0D, 0.0D, 0.0D);
+        this.brightness = -1;
+        if (brightness >= 0) {
+            this.brightness = brightness;
+        }
+        this.xd *= 0.1D;
+        this.yd *= 0.1D;
+        this.zd *= 0.1D;
+        float n = (float) Math.random() * 0.4F + 0.6F;
+        this.rCol = ((float) (Math.random() * 0.2D) + 0.8F) * red * n;
+        this.gCol = ((float) (Math.random() * 0.2D) + 0.8F) * green * n;
+        this.bCol = ((float) (Math.random() * 0.2D) + 0.8F) * blue * n;
+        this.size *= 0.75F;
+        this.size *= scale;
+        this.oSize = this.size;
+        this.lifetime = (int) (8D / (Math.random() * 0.8D + 0.2D));
+        this.lifetime *= (int) scale;
+        this.noPhysics = false;
+    }
+
+    @Override
+    public void render(Tessellator t, float partialTick, double xOff, double yOff, double zOff, float xa, float ya, float za, float xa2, float za2) {
+        float l = ((this.age + partialTick) / this.lifetime) * 32F;
+        if (l < 0.0F) {
+            l = 0.0F;
+        }
+        if (l > 1.0F) {
+            l = 1.0F;
+        }
+        this.size = this.oSize * l;
+        if (this.tex == null) return;
+
+        float u0 = (float) this.tex.getIconUMin();
+        float u2 = (float) this.tex.getSubIconU(1);
+        float v0 = (float) this.tex.getIconVMin();
+        float v2 = (float) this.tex.getSubIconV(1);
+        float r = 0.1F * this.size;
+        float x = (float) (this.xo + (this.x - this.xo) * partialTick - xOff);
+        float y = (float) (this.yo + (this.y - this.yo) * partialTick - yOff);
+        float z = (float) (this.zo + (this.z - this.zo) * partialTick - zOff);
+        float br = 1f;
+        if (LightmapHelper.isLightmapEnabled()) {
+            int xTile = MathHelper.floor(this.x);
+            int yTile = MathHelper.floor(this.y);
+            int zTile = MathHelper.floor(this.z);
+            int lmc;
+            if (this.brightness >= 0) {
+                lmc = LightmapHelper.getLightmapCoord(this.world.getSavedLightValue(LightLayer.Sky, xTile, yTile, zTile), Math.max(this.world.getSavedLightValue(LightLayer.Block, xTile, yTile, zTile), this.brightness));
+            } else {
+                lmc = getLightmapCoord(partialTick);
+            }
+            t.setLightmapCoord(lmc);
+        } else {
+            br = Math.max(getBrightness(partialTick), this.brightness / 15f);
+        }
+        t.setColorOpaque_F(this.rCol * br, this.gCol * br, this.bCol * br);
+        t.addVertexWithUV(x - xa * r - xa2 * r, y - ya * r, z - za * r - za2 * r, u2, v2);
+        t.addVertexWithUV(x - xa * r + xa2 * r, y + ya * r, z - za * r + za2 * r, u2, v0);
+        t.addVertexWithUV(x + xa * r + xa2 * r, y + ya * r, z + za * r + za2 * r, u0, v0);
+        t.addVertexWithUV(x + xa * r - xa2 * r, y - ya * r, z + za * r - za2 * r, u0, v2);
+    }
+
+    @Override
+    public void tick() {
+        this.xo = this.x;
+        this.yo = this.y;
+        this.zo = this.z;
+        if (this.age++ >= this.lifetime) {
+            this.remove();
+        }
+        int val = (7 - ((this.age * 8) / this.lifetime));
+        if (val >= 0) {
+            this.tex = TextureRegistry.getTexture("minecraft:particle/puff_" + val);
+        } else {
+            this.tex = null;
+        }
+        this.move(this.xd, this.yd, this.zd);
+        if (this.y == this.yo) {
+            this.xd *= 1.1D;
+            this.zd *= 1.1D;
+        }
+        this.xd *= 0.96D;
+        this.yd *= 0.96D;
+        this.zd *= 0.96D;
+        if (this.onGround) {
+            this.xd *= 0.7D;
+            this.zd *= 0.7D;
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/entity/particle/ParticleRedstoneDust.java b/src/main/java/net/minecraft/client/entity/particle/ParticleRedstoneDust.java
index 1dc9ee71b..77c9b3129 100644
--- a/src/main/java/net/minecraft/client/entity/particle/ParticleRedstoneDust.java
+++ b/src/main/java/net/minecraft/client/entity/particle/ParticleRedstoneDust.java
@@ -1,9 +1,11 @@
 package net.minecraft.client.entity.particle;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.enums.LightLayer;
+import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 
@@ -11,11 +13,11 @@ public class ParticleRedstoneDust extends Particle {
     private final float oSize;
     private int brightness;
 
-    public ParticleRedstoneDust(World world, double x, double y, double z, float red, float green, float blue, int brightness) {
-        this(world, x, y, z, 1.0F, red, green, blue, brightness);
+    public ParticleRedstoneDust(World world, double x, double y, double z, int brightness) {
+        this(world, x, y, z, 1.0F, brightness);
     }
 
-    public ParticleRedstoneDust(World world, double x, double y, double z, float scale, float red, float green, float blue, int brightness) {
+    public ParticleRedstoneDust(World world, double x, double y, double z, float scale, int brightness) {
         super(world, x, y, z, 0.0D, 0.0D, 0.0D);
         this.brightness = -1;
         if (brightness >= 0) {
@@ -25,6 +27,12 @@ public class ParticleRedstoneDust extends Particle {
         this.yd *= 0.1D;
         this.zd *= 0.1D;
         float n = (float) Math.random() * 0.4F + 0.6F;
+
+        Color color = Colors.allRedstoneColors[MathHelper.clamp(brightness, 0, Colors.allRedstoneColors.length)];
+        float red = color.getRed() / 255.0f;
+        float green = color.getGreen() / 255.0f;
+        float blue = color.getBlue() / 255.0f;
+
         this.rCol = ((float) (Math.random() * 0.2D) + 0.8F) * red * n;
         this.gCol = ((float) (Math.random() * 0.2D) + 0.8F) * green * n;
         this.bCol = ((float) (Math.random() * 0.2D) + 0.8F) * blue * n;
diff --git a/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java b/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
index 7e84bd66d..9e1fa0388 100644
--- a/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
+++ b/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
@@ -335,7 +335,7 @@ public class PlayerLocal extends Player
     public void onItemPickup(Entity entity, ItemStack item)
     {
         addStat(item.getItem().getStat(StatList.STAT_PICKED_UP), 1);
-        mc.particleEngine.add(new ParticlePickupAnimation(mc.theWorld, entity, this, -0.5F));
+        mc.particleEngine.add(new ParticlePickupAnimation(mc.currentWorld, entity, this, -0.5F));
     }
 
     public int getPlayerProtectionAmount()
diff --git a/src/main/java/net/minecraft/client/gui/Gui.java b/src/main/java/net/minecraft/client/gui/Gui.java
index 63ab05fa1..355a19db6 100644
--- a/src/main/java/net/minecraft/client/gui/Gui.java
+++ b/src/main/java/net/minecraft/client/gui/Gui.java
@@ -2,7 +2,7 @@ package net.minecraft.client.gui;
 
 import static org.lwjgl.opengl.GL11.*;
 
-import net.minecraft.client.lang.text.Text;
+import net.minecraft.core.lang.text.Text;
 import net.minecraft.client.render.Font;
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.texture.Texture;
@@ -10,8 +10,6 @@ import net.minecraft.client.render.texture.meta.gui.GuiTextureProperties;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 
-import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.opengl.GL11;
 
diff --git a/src/main/java/net/minecraft/client/gui/Screen.java b/src/main/java/net/minecraft/client/gui/Screen.java
index 494c62451..04e5939b2 100644
--- a/src/main/java/net/minecraft/client/gui/Screen.java
+++ b/src/main/java/net/minecraft/client/gui/Screen.java
@@ -146,7 +146,7 @@ public abstract class Screen extends Gui {
     }
 
     public void renderBackground() {
-        if (mc.theWorld != null) {
+        if (mc.currentWorld != null) {
             int color = mc.gameSettings.guiBackgroundColor.value.getARGB();
             drawGradientRect(0, 0, width, height, color, color);
         } else {
diff --git a/src/main/java/net/minecraft/client/gui/ScreenCreateWorld.java b/src/main/java/net/minecraft/client/gui/ScreenCreateWorld.java
index 421bbc415..0de6dc236 100644
--- a/src/main/java/net/minecraft/client/gui/ScreenCreateWorld.java
+++ b/src/main/java/net/minecraft/client/gui/ScreenCreateWorld.java
@@ -135,7 +135,7 @@ public class ScreenCreateWorld extends Screen {
                 mc.thePlayer.inventory.insertItem(Items.TOOL_AXE_WOOD.getDefaultStack(), true);
             }
             if (mc.worldPresetName != null) mc.thePlayer.setPos(overrideSpawnX, overrideSpawnY, overrideSpawnZ);
-            mc.theWorld.getLevelData().setCheatsEnabled(cheatsEnabled);
+            mc.currentWorld.getLevelData().setCheatsEnabled(cheatsEnabled);
             mc.displayScreen(null);
         } else if (button == gamemodeButton) {
             I18n i18n = I18n.getInstance();
diff --git a/src/main/java/net/minecraft/client/gui/ScreenCredits.java b/src/main/java/net/minecraft/client/gui/ScreenCredits.java
index 3a48b3a61..473ec6d56 100644
--- a/src/main/java/net/minecraft/client/gui/ScreenCredits.java
+++ b/src/main/java/net/minecraft/client/gui/ScreenCredits.java
@@ -224,7 +224,7 @@ public class ScreenCredits extends Screen {
     }
 
     private void overlayBackground(int minX, int maxX, int minY, int maxY) {
-        if (mc.theWorld == null) {
+        if (mc.currentWorld == null) {
             Tessellator tessellator = Tessellator.instance;
             mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
diff --git a/src/main/java/net/minecraft/client/gui/ScreenGameOver.java b/src/main/java/net/minecraft/client/gui/ScreenGameOver.java
index 3eb517bb8..317c7110f 100644
--- a/src/main/java/net/minecraft/client/gui/ScreenGameOver.java
+++ b/src/main/java/net/minecraft/client/gui/ScreenGameOver.java
@@ -57,7 +57,7 @@ public class ScreenGameOver extends Screen
         if(button.id == 2)
         {
             if (mc.isMultiplayerWorld()) {
-                mc.theWorld.sendQuittingDisconnectingPacket();
+                mc.currentWorld.sendQuittingDisconnectingPacket();
             }
             mc.changeWorld(null);
             mc.displayScreen(new ScreenMainMenu());
diff --git a/src/main/java/net/minecraft/client/gui/ScreenLabelEditor.java b/src/main/java/net/minecraft/client/gui/ScreenLabelEditor.java
index 31c650846..c928bc18d 100644
--- a/src/main/java/net/minecraft/client/gui/ScreenLabelEditor.java
+++ b/src/main/java/net/minecraft/client/gui/ScreenLabelEditor.java
@@ -56,7 +56,7 @@ public class ScreenLabelEditor extends Screen
         	item.setCustomName(text);
             mc.displayScreen(null);
 
-            if (mc.theWorld.isClientSide)
+            if (mc.currentWorld.isClientSide)
             {
                 mc.getSendQueue().addToSendQueue(new SetItemNamePacket(slot, text));
             }
diff --git a/src/main/java/net/minecraft/client/gui/ScreenMobPicker.java b/src/main/java/net/minecraft/client/gui/ScreenMobPicker.java
index 2e0249903..197fde605 100644
--- a/src/main/java/net/minecraft/client/gui/ScreenMobPicker.java
+++ b/src/main/java/net/minecraft/client/gui/ScreenMobPicker.java
@@ -60,8 +60,8 @@ public class ScreenMobPicker
             .withOnCloseListener((statusCode, results) -> {
                 if (statusCode == 1) {
                     mobId = monsters.get((Integer) results.get("list"));
-                    if (!mc.theWorld.isClientSide) {
-                        TileEntityMobSpawner spawner = (TileEntityMobSpawner) mc.theWorld.getBlockEntity(x, y, z);
+                    if (!mc.currentWorld.isClientSide) {
+                        TileEntityMobSpawner spawner = (TileEntityMobSpawner) mc.currentWorld.getBlockEntity(x, y, z);
                         if (spawner == null) {
                             return;
                         }
diff --git a/src/main/java/net/minecraft/client/gui/ScreenPause.java b/src/main/java/net/minecraft/client/gui/ScreenPause.java
index d6d91d239..fa3b0380b 100644
--- a/src/main/java/net/minecraft/client/gui/ScreenPause.java
+++ b/src/main/java/net/minecraft/client/gui/ScreenPause.java
@@ -67,7 +67,7 @@ public class ScreenPause extends Screen
             mc.statsCounter.add(StatList.leaveGameStat, 1);
             if(mc.isMultiplayerWorld())
             {
-                mc.theWorld.sendQuittingDisconnectingPacket();
+                mc.currentWorld.sendQuittingDisconnectingPacket();
                 Registries.RECIPES = Registries.RECIPES_LOCAL_COPY;
                 GuidebookPageSearch.searchField.setText("");
                 GuidebookPageManager.searchQuery = SearchQuery.resolve(GuidebookPageSearch.searchField.getText());
@@ -114,11 +114,11 @@ public class ScreenPause extends Screen
     {
         I18n i = I18n.getInstance();
         renderBackground();
-        if(mc == null || mc.theWorld == null) {
+        if(mc == null || mc.currentWorld == null) {
         	mc.displayScreen(null);
         	return;
         }
-        boolean isSaving = !mc.theWorld.pauseScreenSave(updateCounter2++);
+        boolean isSaving = !mc.currentWorld.pauseScreenSave(updateCounter2++);
         if(isSaving || updateCounter < 20)
         {
             float f1 = ((float)(updateCounter % 10) + partialTick) / 10F;
diff --git a/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java b/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java
index bc9e7ffc3..2f0f807b9 100644
--- a/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java
+++ b/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java
@@ -88,8 +88,8 @@ public class ScreenPhotoMode extends Screen
         }
         
         this.previousRenderer = mc.renderer;
-        mc.theWorld.updateSeasonAndLight();
-        originalTOD = mc.theWorld.getWorldTime();
+        mc.currentWorld.updateSeasonAndLight();
+        originalTOD = mc.currentWorld.getWorldTime();
     }
 
     public float getRotation(float partialTick)
@@ -165,7 +165,7 @@ public class ScreenPhotoMode extends Screen
             mc.setRenderer(photoModeRenderer);
         }
 
-        if (!mc.theWorld.isClientSide) {
+        if (!mc.currentWorld.isClientSide) {
             buttons.add(sliderTimeOfDay);
             buttons.add(sliderFog);
             buttons.add(buttonSeason);
@@ -204,13 +204,13 @@ public class ScreenPhotoMode extends Screen
     @Override
     public void removed()
     {
-        mc.theWorld.setWorldTimeUpdateTicks(originalTOD);
+        mc.currentWorld.setWorldTimeUpdateTicks(originalTOD);
         
         if(Shaders.enableShaders) {
             mc.setRenderer(previousRenderer);
         }
 
-        mc.theWorld.updateSeasonAndLight();
+        mc.currentWorld.updateSeasonAndLight();
     }
 
     @Override
@@ -240,8 +240,8 @@ public class ScreenPhotoMode extends Screen
                 desiredDay = (long) Global.DAY_LENGTH_TICKS * 7 * desiredSeason + Global.DAY_LENGTH_TICKS * 3L;
             }
 
-            mc.theWorld.setWorldTimeUpdateTicks(desiredDay + desiredTOD);
-            mc.theWorld.updateSeasonAndLight();
+            mc.currentWorld.setWorldTimeUpdateTicks(desiredDay + desiredTOD);
+            mc.currentWorld.updateSeasonAndLight();
         }
         else if (button == buttonTakeScreenshot)
         {
@@ -407,8 +407,8 @@ public class ScreenPhotoMode extends Screen
                 desiredTOD = sliderTOD;
             }
 
-            mc.theWorld.setWorldTimeUpdateTicks(desiredDay + desiredTOD);
-            mc.theWorld.updateSeasonAndLight();
+            mc.currentWorld.setWorldTimeUpdateTicks(desiredDay + desiredTOD);
+            mc.currentWorld.updateSeasonAndLight();
 
             updateButtonsText();
         }
diff --git a/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java b/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
index aa5c6720d..1e7dc56f8 100644
--- a/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
+++ b/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
@@ -45,7 +45,7 @@ public class ScreenSignEditor extends Screen
         Keyboard.enableRepeatEvents(false);
         // I have no idea how the hell the world is null sometimes
         // but thaboar was getting a crash from the world being null
-        if(mc.theWorld != null && mc.theWorld.isClientSide)
+        if(mc.currentWorld != null && mc.currentWorld.isClientSide)
         {
             mc.getSendQueue().addToSendQueue(new SignUpdatePacket(entitySign.x, entitySign.y, entitySign.z, entitySign.signText, entitySign.getPicture().getId(), entitySign.getColor().id));
         }
diff --git a/src/main/java/net/minecraft/client/gui/ScreenSoundTest.java b/src/main/java/net/minecraft/client/gui/ScreenSoundTest.java
index 58a2f9a78..410b6b9fc 100644
--- a/src/main/java/net/minecraft/client/gui/ScreenSoundTest.java
+++ b/src/main/java/net/minecraft/client/gui/ScreenSoundTest.java
@@ -175,7 +175,7 @@ public class ScreenSoundTest extends Screen {
     public void renderBackground() {
         super.renderBackground();
 
-        if (mc.theWorld == null)
+        if (mc.currentWorld == null)
         {
             Tessellator tessellator = Tessellator.instance;
             mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
@@ -211,7 +211,7 @@ public class ScreenSoundTest extends Screen {
 
     private void overlayBackground(int minX, int maxX, int minY, int maxY)
     {
-        if (mc.theWorld == null)
+        if (mc.currentWorld == null)
         {
             Tessellator tessellator = Tessellator.instance;
             mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
diff --git a/src/main/java/net/minecraft/client/gui/ScreenTextureViewer.java b/src/main/java/net/minecraft/client/gui/ScreenTextureViewer.java
index ceca4cbfd..24bc5aa4f 100644
--- a/src/main/java/net/minecraft/client/gui/ScreenTextureViewer.java
+++ b/src/main/java/net/minecraft/client/gui/ScreenTextureViewer.java
@@ -208,7 +208,7 @@ public class ScreenTextureViewer extends Screen {
     public void renderBackground() {
         super.renderBackground();
 
-        if (mc.theWorld == null)
+        if (mc.currentWorld == null)
         {
             Tessellator tessellator = Tessellator.instance;
             mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
diff --git a/src/main/java/net/minecraft/client/gui/ScreenWandMobPicker.java b/src/main/java/net/minecraft/client/gui/ScreenWandMobPicker.java
index fad7d17c6..648a958f7 100644
--- a/src/main/java/net/minecraft/client/gui/ScreenWandMobPicker.java
+++ b/src/main/java/net/minecraft/client/gui/ScreenWandMobPicker.java
@@ -54,7 +54,7 @@ public class ScreenWandMobPicker extends Screen {
                 .withOnCloseListener((statusCode, results) -> {
                     if (statusCode == 1) {
                         mobId = monsters.get((Integer) results.get("list"));
-                        if (!mc.theWorld.isClientSide) {
+                        if (!mc.currentWorld.isClientSide) {
                             wand.getData().putString("monster", mobId);
                         } else {
                             mc.getSendQueue().addToSendQueue(new CustomPayloadPacket("BTA|WandMonster", mobId.getBytes(StandardCharsets.UTF_8)));
diff --git a/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java b/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
index 652d1b877..39f482a97 100644
--- a/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
+++ b/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
@@ -153,7 +153,7 @@ public class ScreenAchievements extends Screen
         int achMaxX = Integer.MIN_VALUE;
         int achMaxY = Integer.MIN_VALUE;
 
-        for (Achievement ach : currentPage.getAchievements()){
+        for (AchievementPage.AchievementEntry ach : currentPage.getAchievementEntries()){
             if (ach.x < achMinX){
                 achMinX = ach.x;
             }
@@ -179,7 +179,7 @@ public class ScreenAchievements extends Screen
         shiftMaxY += (int) (viewportHeight/4d);
 
         // Centers the screen on the Open ContainerInventory achievement
-        Achievement ach = currentPage.onOpenAchievement();
+        AchievementPage.AchievementEntry ach = currentPage.onOpenAchievement();
         oldShiftX = targetShiftX = currentShiftX = ach.x * ACHIEVEMENT_CELL_WIDTH + ACHIEVEMENT_CELL_WIDTH/2d;
         oldShiftY = targetShiftY = currentShiftY = ach.y * ACHIEVEMENT_CELL_HEIGHT + ACHIEVEMENT_CELL_HEIGHT/2d;
     }
@@ -399,12 +399,6 @@ public class ScreenAchievements extends Screen
 
             if (hoveredPage != null){
                 String msg = font.wrapFormattedStringToWidth(hoveredPage.getDescription(), TOOLTIP_BOX_WIDTH_MIN);
-                int completed = 0;
-                for (Achievement a : hoveredPage.getAchievements()){
-                    if (statsCounter.isUnlocked(a)){
-                        completed++;
-                    }
-                }
                 msg += "\n" + TextFormatting.LIGHT_GRAY + I18n.getInstance().translateKeyAndFormat("gui.achievements.label.completion",  Math.round(hoveredPage.getCompletionFraction(statsCounter) * 100) + "%");
                 tooltip.render(msg, xm, ym, TOOLTIP_OFF_X, TOOLTIP_OFF_Y);
             }
@@ -526,7 +520,7 @@ public class ScreenAchievements extends Screen
                 layer.resize(tilesWide, tilesTall);
             }
 
-            long worldSeed = mc.theWorld == null ? 0 : mc.theWorld.getRandomSeed();
+            long worldSeed = mc.currentWorld == null ? 0 : mc.currentWorld.getRandomSeed();
             for (int _y = 0; _y < tilesTall; _y++){
                 for (int _x = 0; _x < tilesWide; _x++) {
                     int tileX = orgX + _x + viewTileX;
@@ -729,17 +723,19 @@ public class ScreenAchievements extends Screen
     private void drawConnectingLines(int mouseX, int mouseY, double shiftX, double shiftY){
         double zoom = viewportZoom;
 
-        for(Achievement ach : currentPage.getAchievements()) {
-            if(ach.parent == null) {
+        for(AchievementPage.AchievementEntry entry : currentPage.getAchievementEntries()) {
+            Achievement ach = entry.achievement;
+            AchievementPage.AchievementEntry parentEntry = currentPage.getEntry(ach.parent);
+            if(parentEntry == null) {
                 continue;
             }
             if (!currentPage.hasAchievement(ach) || !currentPage.hasAchievement(ach.parent)){
                 continue;
             }
-            double childX = (viewportLeft + viewportWidth/2d) + ((ach.x * ACHIEVEMENT_CELL_WIDTH - shiftX) + 11) * zoom;
-            double childY = (viewportTop + viewportHeight/2d) + ((ach.y * ACHIEVEMENT_CELL_HEIGHT - shiftY) + 11) * zoom;
-            double parentX = (viewportLeft + viewportWidth/2d) + ((ach.parent.x * ACHIEVEMENT_CELL_WIDTH - shiftX) + 11) * zoom;
-            double parentY = (viewportTop + viewportHeight/2d) + ((ach.parent.y * ACHIEVEMENT_CELL_HEIGHT - shiftY) + 11) * zoom;
+            double childX = (viewportLeft + viewportWidth/2d) + ((entry.x * ACHIEVEMENT_CELL_WIDTH - shiftX) + 11) * zoom;
+            double childY = (viewportTop + viewportHeight/2d) + ((entry.y * ACHIEVEMENT_CELL_HEIGHT - shiftY) + 11) * zoom;
+            double parentX = (viewportLeft + viewportWidth/2d) + ((parentEntry.x * ACHIEVEMENT_CELL_WIDTH - shiftX) + 11) * zoom;
+            double parentY = (viewportTop + viewportHeight/2d) + ((parentEntry.y * ACHIEVEMENT_CELL_HEIGHT - shiftY) + 11) * zoom;
             boolean unlocked = statsCounter.isUnlocked(ach);
             boolean canUnlock = statsCounter.canUnlock(ach);
 
@@ -787,9 +783,10 @@ public class ScreenAchievements extends Screen
         double zoom = viewportZoom;
 
         Achievement hoveredAchievment = null;
-        for(Achievement ach : currentPage.getAchievements()) {
-            double achViewX = (viewportLeft + viewportWidth/2d) + (ach.x * ACHIEVEMENT_CELL_WIDTH - shiftX ) * zoom;
-            double achViewY = (viewportTop + viewportHeight/2d) + (ach.y * ACHIEVEMENT_CELL_HEIGHT - shiftY) * zoom;
+        for(AchievementPage.AchievementEntry entry : currentPage.getAchievementEntries()) {
+            Achievement ach = entry.achievement;
+            double achViewX = (viewportLeft + viewportWidth/2d) + (entry.x * ACHIEVEMENT_CELL_WIDTH - shiftX ) * zoom;
+            double achViewY = (viewportTop + viewportHeight/2d) + (entry.y * ACHIEVEMENT_CELL_HEIGHT - shiftY) * zoom;
             if(achViewX < viewportLeft - ACHIEVEMENT_CELL_WIDTH * zoom || achViewY < viewportTop - ACHIEVEMENT_CELL_HEIGHT * zoom || achViewX > viewportRight || achViewY > viewportBottom) { // Continue if outside viewport
                 continue;
             }
diff --git a/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPage.java b/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPage.java
index 689a41eeb..70521a8a7 100644
--- a/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPage.java
+++ b/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPage.java
@@ -12,22 +12,27 @@ import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.ArrayList;
+import java.util.HashMap;
 import java.util.List;
+import java.util.Map;
 import java.util.Objects;
 import java.util.Random;
 
 public abstract class AchievementPage {
-    private final List<Achievement> achievementList = new ArrayList<>();
+    private final Map<Achievement, AchievementEntry> entryMap = new HashMap<>();
+    private final List<AchievementEntry> achievementList = new ArrayList<>();
 
     public abstract @NotNull String getName();
 
     public abstract @NotNull String getDescription();
 
-    public void addAchievement(@NotNull Achievement achievement) {
-        achievementList.add(Objects.requireNonNull(achievement));
+    public void addAchievement(@NotNull Achievement achievement, int x, int y) {
+        AchievementEntry entry = new AchievementEntry(Objects.requireNonNull(achievement), x, y);
+        achievementList.add(entry);
+        entryMap.put(achievement, entry);
     }
 
-    public abstract @NotNull Achievement onOpenAchievement();
+    public abstract @NotNull AchievementEntry onOpenAchievement();
 
     public abstract @Nullable IconCoordinate getBackgroundTile(ScreenAchievements screen, int layer, Random random, int tileX, int tileY);
 
@@ -35,14 +40,18 @@ public abstract class AchievementPage {
 
     public abstract @NotNull ItemStack getIcon();
 
-    public @NotNull List<Achievement> getAchievements() {
+    public @NotNull List<AchievementEntry> getAchievementEntries() {
         return achievementList;
     }
 
+    public @Nullable AchievementEntry getEntry(Achievement achievement) {
+        return entryMap.get(achievement);
+    }
+
     public double getCompletionFraction(StatsCounter counter) {
         int completed = 0;
-        for (Achievement a : achievementList) {
-            if (counter.isUnlocked(a)) {
+        for (AchievementEntry a : achievementList) {
+            if (counter.isUnlocked(a.achievement)) {
                 completed++;
             }
         }
@@ -54,7 +63,7 @@ public abstract class AchievementPage {
     public abstract int backgroundColor();
 
     public boolean hasAchievement(Achievement achievement) {
-        return achievementList.contains(achievement);
+        return entryMap.containsKey(achievement);
     }
 
     public abstract IconCoordinate getAchievementIcon(Achievement achievement);
@@ -68,4 +77,15 @@ public abstract class AchievementPage {
     public static IconCoordinate getTextureFromBlock(Block block) {
         return BlockModelDispatcher.getInstance().getDispatch(block).getBlockTextureFromSideAndMetadata(Side.TOP, 0);
     }
+
+    public static class AchievementEntry {
+        public final int x;
+        public final int y;
+        public final @NotNull Achievement achievement;
+        public AchievementEntry(@NotNull Achievement achievement, int x, int y) {
+            this.achievement = achievement;
+            this.x = x;
+            this.y = y;
+        }
+    }
 }
